package net.nitus.museu.migraCoordenades;

import java.util.StringTokenizer;

/**
 * Modela les dades de les línies: Field 0: Type=String, Title=`TIPUS_LIM', Width=1, Decimals=0
 * 
 * @author xnavarro
 *
 */
public class Field {
	private int idField;
	private String tipus;
	private String titol;
	private int amplada;
	private int decimals;
	
	/**
	 * Constructor a partir de la línia del shapefile
	 * @param camp
	 */
	public Field(String camp) {
		//Field 0: Type=String, Title=`TIPUS_LIM', Width=1, Decimals=0
		int comptaTokens = 0;
		String token;
		String resta="";
		StringTokenizer st = new StringTokenizer(camp, ":");
		while (st.hasMoreTokens()) {
            token = st.nextToken();
            comptaTokens++;
            if (comptaTokens==1) this.idField=new Integer(token.substring((token.indexOf(' '))+1)).intValue();
            else resta=token;
        }
		st = new StringTokenizer(resta, ",");
		while (st.hasMoreTokens()) {
            token = st.nextToken();
            String valor = token.substring(token.indexOf('=')+1);
            if (token.startsWith(" Type=")) this.tipus=valor;
            else if (token.startsWith(" Title=")) this.titol=valor;
            else if (token.startsWith(" Width=")) this.amplada=new Integer(valor).intValue();
            else if (token.startsWith(" Decimals=")) this.decimals=new Integer(valor).intValue();
        }
	}
	
	/**
	 * Sobreescriu el mètode toString();
	 */
	public String toString(){
		String cadena = "[";
		cadena += "Field "+this.idField+": ";
		cadena += "Tipus="+this.tipus+", ";
		cadena += "Titol="+this.titol+", ";
		cadena += "Width="+this.amplada+", ";
		cadena += "Decimals="+this.decimals+", ";
		cadena += "]";
		return cadena;
	}
}
