package net.nitus.museu.context;

import java.math.BigDecimal;

/**
 * Classe que implementa un jaciment
 * @author xnavarro
 *
 */
public class Jaciment {
	private int id;
	private String nom;
	private String uNom;
	private String poblacio;
	private GeoCoordenadaDigital posicio;
	private String imatge;
	private Integer xImatge;
	private Integer yImatge;
	private String comentaris;
	
	public Jaciment(){
		this.id=-1;
		this.nom=null;
		this.uNom=null;
		this.poblacio=null;
		this.posicio=new GeoCoordenadaDigital(null, null);
		this.imatge=null;
		this.comentaris=null;
	}

	public String toString(){
		String classe = "[\n";
		classe+= "Id: "+getId()+", ";
		classe+= "nom: "+getNom()+", ";
		classe+= "unom "+getuNom()+", ";
		classe+= "poblacio: "+getPoblacio()+", ";
		classe+= "longitud: "+getLongitud()+", ";
		classe+= "latitud: "+getLatitud()+", ";
		classe+= "imatge: "+getImatge()+", ";
		classe+= "comentaris: "+getComentaris()+", ";
		classe+= "]";
		return classe;
	}

	// Els getters i els setters.
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getuNom() {
		return uNom;
	}

	public void setuNom(String uNom) {
		this.uNom = uNom;
	}

	public String getPoblacio() {
		return poblacio;
	}

	public void setPoblacio(String poblacio) {
		this.poblacio = poblacio;
	}

	public GeoCoordenadaDigital getPosicio() {
		return posicio;
	}

	public void setPosicio(GeoCoordenadaDigital posicio) {
		this.posicio = posicio;
	}

	public BigDecimal getLongitud() {
		return getPosicio().getLongitud();
	}

	public void setLongitud(BigDecimal longitud) {
		this.posicio.setLongitud(longitud);
	}

	public BigDecimal getLatitud() {
		return getPosicio().getLatitud();
	}

	public void setLatitutd(BigDecimal latitud) {
		this.posicio.setLongitud(latitud);
	}

	public String getImatge() {
		return imatge;
	}

	public void setImatge(String imatge) {
		this.imatge = imatge;
	}

	public String getComentaris() {
		return comentaris;
	}

	public void setComentaris(String comentaris) {
		this.comentaris = comentaris;
	}

	public Integer getxImatge() {
		return xImatge;
	}

	public void setxImatge(int xImatge) {
		this.xImatge = xImatge;
	}
	public void setxImatge(String xImatge) {
		this.xImatge=new Integer(xImatge);
	}
	
	public Integer getyImatge() {
		return yImatge;
	}

	public void setyImatge(int yImatge) {
		this.yImatge = yImatge;
	}

	public void setyImatge(String yImatge) {
		this.yImatge=new Integer(yImatge);
	}

}
