
obert = false;
var treballant=false;
var diapositives = new Array();
var actual = 0;

/**
 * Pregàrrega de les imatges dels botons
 */
if (document.images) {
 esquerraOver=new Image(35,36); 
 esquerraOver.src="image/esquerraOver.png"; 
 esquerraOut=new Image(35,36); 
 esquerraOut.src="image/esquerraOut.png"; 
 esquerraDeshabilitat=new Image(35,36); 
 esquerraDeshabilitat.src="image/esquerraDeshabilitat.png"; 
 dretaOver=new Image(35,36); 
 dretaOver.src="image/dretaOver.png"; 
 dretaOut=new Image(35,36); 
 dretaOut.src="image/dretaOut.png"; 
 dretaDeshabilitat=new Image(35,36); 
 dretaDeshabilitat.src="image/dretaDeshabilitat.png"; 
}

/**
 * Busca la referència al layer en funció del navegador
 * @param divID
 * @param oDoc
 * @return
 */
function camiDelLayer(divID,oDoc) {
  if( document.getElementById ) {
    return document.getElementById(divID); }
  if( document.all ) {
    return document.all[divID]; }
  if( !oDoc ) { oDoc = document; }
  if( document.layers ) {
    if( oDoc.layers[divID] ) { return oDoc.layers[divID]; } else {
      for( var x = 0, y; !y && x < oDoc.layers.length; x++ ) {
        y = getRefToDiv(divID,oDoc.layers[x].document); }
    return y; } }
  return false;
}

/**
 * Mostra un layer 
 * @param idLayer
 * @return
 */
function mostraLayer(idLayer) {
  elLayer = camiDelLayer(idLayer);
  if( !elLayer ) {
    window.alert('Aquest navegador no suporta layers.');
    return;
  }
  if( elLayer.style ) {
    elLayer.style.visibility = 'visible';
  } else {
    elLayer.visibility = 'show';
  }
}

/**
 * Amaga un layer
 * @param idLayer
 * @return
 */
function amagaLayer(idLayer) {
  elLayer = camiDelLayer(idLayer);
  if( !elLayer ) {
    window.alert('Aquest navegador no suporta layers.');
    return;
  }
  if( elLayer.style ) {
    elLayer.style.visibility = 'hidden';
  } else {
    elLayer.visibility = 'hide';
  }
}

/**
 * Obté la posició top
 * @param idLayer
 * @return
 */
function obteTop(idLayer){
  elLayer = camiDelLayer(idLayer);
  var noPx = document.childNodes ? 'px' : 0;
  if( elLayer.style ) { 
    elLayer = elLayer.style; 
  }
  return parseInt(elLayer.top);
}

/**
 * Obté la posició left del layer
 * @param idLayer
 * @return
 */
function obteLeft(idLayer){
  elLayer = camiDelLayer(idLayer);
  var noPx = document.childNodes ? 'px' : 0;
  if( elLayer.style ) {
    elLayer = elLayer.style; 
  }
  return parseInt(elLayer.left);
}

/**
 * Obté l'amplada del layer
 * @param idLayer
 * @return
 */
function obteAmplada(idLayer){
  elLayer = camiDelLayer(idLayer);
  var noPx = document.childNodes ? 'px' : 0;
  if( elLayer.style ) { 
    elLayer = elLayer.style; 
  }
  return parseInt(elLayer.width);
}

/**
 * Obté l'alsada del layer
 * @param idLayer
 * @return
 */
function obteAlsada(idLayer){
  elLayer = camiDelLayer(idLayer);
  var noPx = document.childNodes ? 'px' : 0;
  if( elLayer.style ) { 
    elLayer = elLayer.style; 
  }
  return parseInt(elLayer.heigh);
}

/**
 * Estableix la posició left del layer
 * @param idLayer
 * @param valorLeft
 * @return
 */
function estableixLeft(idLayer, valorLeft) {
  var elLayer = camiDelLayer(idLayer), noPx = document.childNodes ? 'px' : 0;
  if( !elLayer ) {
    window.alert('Aquest navegador no suporta layers.');
    return;
  }
  if( elLayer.style ) { 
    elLayer = elLayer.style; 
  }
  elLayer.left = valorLeft + noPx;
}

/**
 * Estableix la posició top del layer
 * @param idLayer
 * @param valorTop
 * @return
 */
function estableixTop(idLayer, valorTop) {
  var elLayer = camiDelLayer(idLayer), noPx = document.childNodes ? 'px' : 0;
  if( !elLayer ) {
    window.alert('Aquest navegador no suporta layers.');
    return;
  }
  if( elLayer.style ) { 
    elLayer = elLayer.style; 
  }
  elLayer.top = valorTop + noPx;
}

/**
 * Escriu el contingut del layer
 * @param idLayer
 * @param text
 * @return
 */
function escriuLayer(idLayer, text) {
  var elLayer = camiDelLayer(idLayer);
  if( !elLayer ) {
    window.alert('Aquest navegador no suporta layers.');
	return;
  }

  if( elLayer.innerHTML ) { 
	elLayer.innerHTML = text; 
  } 
  else {
	if( elLayer.document && elLayer.document != window.document ) {
	  elLayer.document.open();
	  elLayer.document.write( text );
	  elLayer.document.close();
	} 
	else {
	  // El navegador no permet reescriure layers. 
	  return; 
	}
  }
}

/**
 * Estableix la mida del layer
 * @param idLayer
 * @param valorAmplada
 * @param valorAlsada
 * @return
 */
function estableixMida(idLayer, valorAmplada, valorAlsada){
  elLayer = camiDelLayer(idLayer);
  if( elLayer.style ) { 
    elLayer = elLayer.style; 
  }
  if( elLayer.resizeTo ) {
    elLayer.resizeTo( valorAmplada, valorAlsada );
  }
  var noPx = document.childNodes ? 'px' : 0;
  elLayer.width = valorAmplada + noPx;
  elLayer.pixelWidth = valorAmplada;
  elLayer.height = valorAlsada + noPx;
  elLayer.pixelHeight = valorAlsada;
}

/**
 * Crea un nou layer
 * @param idPare
 * @param idLayer
 * @param text
 * @return
 */
function creaLayer(idPare, idLayer, text) {
  window.oPsnx = window.oPsnx ? ( window.oPsnx + 1 ) : 1;
  
  if( document.layers && window.Layer ) {
    var a = new Layer( 0, document.layers[idPare] );
    a.document.open();
    a.document.write(text);
    a.document.close();
    a.bgColor = '#AAAAAA;'; 
    a.left = 0; 
    a.top = 0; 
    a.visibility = 'hide';
  } else {
    var a = camiDelLayer(idPare);
    var theString = '<div id='+idLayer+
                    ' style="position:absolute;'+
                            'left: 0px;'+
                            'top: 0 px;'+
                            'width:0px;'+
                            'background-color: #AAAAAA;'+
                    '" class="diapositiva">'+text+
                    '<\/div>';
    if( a.iinsertAdjacentHTML ) { 
      a.insertAdjacentHTML('beforeEnd',theString);
    } 
    else if( typeof( a.innerHTML ) != 'undefined' ) {
      a.innerHTML += theString;
    } 
    else { 
      window.alert('Aquest navegador no suporta els layers correctment.'); 
    }
  }
}

/**
 * Esborra un layer
 * @param idLayer
 * @return
 */
function esborraLayer(idLayer) {
 if (document.getElementById && document.getElementById(idLayer)) {
  var theNode = document.getElementById(idLayer);
  theNode.parentNode.removeChild(theNode);
 }
 else if (document.all && document.all[idLayer]) {
  document.all[idLayer].innerHTML='';
  document.all[idLayer].outerHTML='';
 }
 // OBSOLETE CODE FOR NETSCAPE 4 
 else if (document.layers && document.layers[idLayer]) {
  document.layers[idLayer].visibility='hide';
  delete document.layers[idLayer];
 }
}

/**
 * Obre el reproductor
 * @param idLayer
 * @param xmlInfo
 * @return
 */
function obreReproductor(idLayer, xmlInfo){
  mostraLayer( idLayer );
  if (xmlInfo) carregaJaciment('areaReproduccio', xmlInfo);
  else carregaMuseu('areaReproduccio');
  obert = true;
}

/**
 * Tanca el reproductor
 * @param idLayer
 * @return
 */
function tancaReproductor(idLayer){
  netejaLayers( idLayer );
  esborraLayer('infoDiapositives');
  amagaLayer( idLayer );
  obert = false;
}

/**
 * Obre el reproductor amb la informació del museu
 * @param layerPare El layer pare que conté el reproductor
 * @param xmlInfo null. En els jaciments porta la informació del jaciment
 */
function carregaMuseu(layerPare, xmlInfo){
  netejaLayers(layerPare);
  var nom;
  var html = '';
  html = html+'<table width="100%" border="0" cellspacing="0" cellpadding="0">\n'+
   		      '  <tr>\n'+
		  	  '	      <td><span class="municipi">\n';
  html = html+'           Museu Municipal de Molins de Rei ';
  html = html+'           <br>\n'+
  		      '      <span class="poblacio">\n';
  html = html+'           Carrer del Pintor Fortuny, 55<br>' +
              '           <u>08750 Molins De Rei</u><br>';
  html = html+'           </span></span></td>\n'+
		  	  '    <td><p align="right" class="periode"><span class="poblacio">';
  html = html+'        </span><br>\n'+
		  	  '        <span class="dates">';
  html = html+'        </span></p>      </td>\n'+
		  	  '  </tr>\n'+
		  	  '  <tr>\n'+
		  	  '    <td colspan="2" align="center"><table width="99%" border="0" cellspacing="0" cellpadding="0">\n'+
		  	  '      <tr>\n'+
		  	  '        <td colspan="2"><div align="justify"><span class="periode"><span class="descPeriode">';
  html = html+'        </span></span></div></td>\n'+
              '        </tr>\n'+
              '      <tr>\n'+
              '        <td width="30%"><span class="descObjecte">';
  html = html+'        Plànol del museu';
  html = html+'        </span></td>\n'+
		  	  '        <td width="70%"><div align="center">';
  html = html+'          <img src="/museu/image/planol.png" alt="Planol" width="354" height="200" longdesc="Planol del museu."></div></td>\n'; 
  html = html+'      </tr>\n'+
	  		  '      \n'+
		  	  '    </table></td>\n'+
		  	  '    </tr>\n'+
		  	  '</table>\n';

  html = html+'</div>';
  creaDiapositiva(layerPare, 'diapositiva1', html);
  diapositives.push('diapositiva1');
  estableixTitol('Museu Municipal de Molins de Rei');
	  
  creaLayer('controlsReproduccio','infoDiapositives','Diapositiva 1 de '+diapositives.length+'.');
  estableixMida('infoDiapositives', 120, 15);
  estableixTop('infoDiapositives', 20);
  estableixLeft('infoDiapositives', 630);  
  if (diapositives.length!=0) mostraDiapositiva(diapositives[0]);
  botoOut('esquerra');
  botoOut('dreta');
}

/**
 * Carrega les diapositives del jaciment al projector
 * @param layerPare
 * @param xmlInfo
 * @return
 */
function carregaJaciment(layerPare, xmlInfo){
  netejaLayers(layerPare);
  var nom;
  var jaciments = xmlInfo.getElementsByTagName("diapositiva");
  for (var i = 0; i < jaciments.length; i++) {
    var html = '<table width="100%" border="0" cellspacing="0" cellpadding="0">\n'+
	  		   '  <tr>\n'+
	  		   '	      <td><span class="municipi">\n';
	nom = jaciments[i].getElementsByTagName("nom")[0].firstChild.nodeValue; 
	if (nom.length!=0) html = html+' '+nom+' ';
	html = html+'          <br>\n'+
	  		   '      <span class="poblacio">\n';
    var poblacio = '';
	  if (jaciments[i].getElementsByTagName("poblacio")[0].childNodes.length!=0) {
		poblacio = jaciments[i].getElementsByTagName("poblacio")[0].firstChild.nodeValue;
	  }
	html = html+poblacio;
	html = html+'</span></span></td>\n'+
	  		   '    <td><p align="right" class="periode"><span class="poblacio">';
    var periode = '';
	if (jaciments[i].getElementsByTagName("periode")[0].childNodes.length!=0) {
	  periode = jaciments[i].getElementsByTagName("periode")[0].firstChild.nodeValue;
	}
	html = html+periode;
	html = html+'</span><br>\n'+
	  		   '        <span class="dates">';
	var dates = '';
	if (jaciments[i].getElementsByTagName("dates")[0].childNodes.length!=0) {
	  dates = jaciments[i].getElementsByTagName("dates")[0].firstChild.nodeValue;
	}
	html = html+dates;
	html = html+'</span></p>      </td>\n'+
	  		   '  </tr>\n'+
	  		   '  <tr>\n'+
	  		   '    <td colspan="2" align="center"><table width="99%" border="0" cellspacing="0" cellpadding="0">\n'+
	  		   '      <tr>\n'+
	  		   '        <td colspan="2"><div align="justify"><span class="periode"><span class="descPeriode">';
	var descripcioPeriode = '';
	if (jaciments[i].getElementsByTagName("descripcioPeriode")[0].childNodes.length!=0) {
		descripcioPeriode = jaciments[i].getElementsByTagName("descripcioPeriode")[0].firstChild.nodeValue;
	}
	html = html+'<br>'+descripcioPeriode;
	var altres = '';
	if (jaciments[i].getElementsByTagName("altres")[0].childNodes.length!=0) {
		altres = jaciments[i].getElementsByTagName("altres")[0].firstChild.nodeValue;
	}
	if (altres!='') html = html+'<br>&nbsp;<br>'+altres;
	html = html+'</span> .</span></div></td>\n'+
	  		   '        </tr>\n'+
	  		   '      <tr>\n'+
	  		   '        <td width="30%"><span class="descObjecte">';
	var descripcioObjecte = '';
	if (jaciments[i].getElementsByTagName("descripcioObjecte")[0].childNodes.length!=0) {
		descripcioObjecte = jaciments[i].getElementsByTagName("descripcioObjecte")[0].firstChild.nodeValue;
	}
	html = html+descripcioObjecte;
	html = html+'</span></td>\n'+
	  		   '        <td width="70%"><div align="center">';
	var imatge = '';
	if (jaciments[i].getElementsByTagName("urlImatge")[0].childNodes.length!=0) {
		imatge = jaciments[i].getElementsByTagName("urlImatge")[0].firstChild.nodeValue;
	}
	if (imatge!=''){
		var amplada = jaciments[i].getElementsByTagName("xImatge")[0].firstChild.nodeValue;
		var alsada = jaciments[i].getElementsByTagName("yImatge")[0].firstChild.nodeValue;
		html = html + '<img src="'+imatge+'" alt="Fotografia" width="'+amplada+'" height="'+alsada+'" longdesc="'+descripcioObjecte+'"></div></td>\n'; 
	}
	html = html+'      </tr>\n'+
	  		   '      \n'+
	  		   '    </table></td>\n'+
	  		   '    </tr>\n'+
	  		   '</table>\n';

    html = html+'</div>';
	creaDiapositiva(layerPare, 'diapositiva'+i, html);
    diapositives.push('diapositiva'+i);
  } // Fi del for
  estableixTitol(nom);
  
  creaLayer('controlsReproduccio','infoDiapositives','Diapositiva 1 de '+diapositives.length+'.');
  estableixMida('infoDiapositives', 120, 15);
  estableixTop('infoDiapositives', 20);
  estableixLeft('infoDiapositives', 630);  
  if (diapositives.length!=0) mostraDiapositiva(diapositives[0]);
  botoOut('esquerra');
  botoOut('dreta');
}

/**
 * Neteja tots els layers que pengen del pare
 * @param layerPare
 * @return
 */
function netejaLayers(layerPare){
  for (var i=0; i<diapositives.length;i++){
    esborraLayer(diapositives[i]);  
  }
  diapositives = new Array();
  actual = 0;
  botoOut('esquerra');
  botoOut('dreta');
}

/**
 * Crea una diapositiva a partir del text html
 * @param idPare
 * @param idLayer
 * @param text
 * @return
 */
function creaDiapositiva(idPare, idLayer, text){
  creaLayer(idPare, idLayer, text);
  estableixMida(idLayer, 10, 400);
  estableixTop(idLayer, 10);
  estableixLeft(idLayer, 0);
  amagaLayer(idLayer);
}

/**
 * Estableix el títol de la finestra projector
 * @param titol
 * @return
 */
function estableixTitol(titol){
	html = '<table width="754" border="0" cellpadding="0" cellspacing="0">'+
		   '   <tr>'+
		   '    <td width="732">'+
		   titol+' \n'+
		   '    </td>'+
		   '    <td width="20">'+
		   '      <a href="javascript:tancaReproductor(\'reproductor\');">'+
		   '        <img src="image/tancar.png" alt="Tancar" width="20" height="20" border="0" longdesc="Botó de tancar la finestra.">'+
		   '      </a>'+
		   '    </td>'+
	       '  </tr>'+
	       '</table>';
	escriuLayer('titolReproductor',html);
}

/**
 * Mostra una diapositiva
 * @param idDiapositiva
 * @return
 */
function mostraDiapositiva(idDiapositiva){
  estableixMida(idDiapositiva, 740, 400);  
  mostraLayer(idDiapositiva);
  estableixLeft(idDiapositiva, 10);
}

/**
 * Mou la diapositiva a la dreta
 * @return
 */
function mouDreta(){
  // Si no hi ha dues diapositives, no es mou res.
  if (diapositives.length < 2) return
  // Per evitar que ens apretin massa vegades el botó.
  treballant = true;                 
  // Calculem la següent
  var seguent = actual+1;
  if (seguent == diapositives.length) seguent=0;

  // Llegim la posició actual
  var posicio = parseInt(obteLeft(diapositives[actual]));
  posicio = posicio + 10;

  if (posicio <= 20) { // Inicialitzem el layer de l'esquerra
    estableixLeft(diapositives[seguent],0);
    estableixMida(diapositives[seguent],0,400);
  }
  //Ho movem tot cap a la dreta  
  mostraLayer(diapositives[seguent]);
  estableixMida(diapositives[seguent], posicio-10, 400);  
  estableixLeft(diapositives[actual],posicio);
  estableixMida(diapositives[actual], 740-posicio+20, 400);  

  // Si no hem acabat, tornem-hi
  if (posicio<740) setTimeout("mouDreta();",20);
  else { // Hem acabat. 
    // amaguem la diapositiva antiga
    amagaLayer(diapositives[actual]);
    // acabem de posicionar la diapositiva nova
    estableixMida(diapositives[seguent],740);  
    estableixLeft(diapositives[seguent],10);
    // actualitzem la diapositiva que s'està mostrant
    actual=seguent;
    escriuLayer('infoDiapositives','Diapositiva '+(actual+1)+' de '+diapositives.length+'.');
    // ja ens poden tornar a apretar el botó
    treballant=false;
  }
}

/**
 * Mostra la següent diapositiva
 * @return
 */
function seguentDiapositiva(){
  if (treballant) return;
  mouDreta();
}

/**
 * Mou la diapositiva a l'esquerra
 * @return
 */
function mouEsquerra(){
  // Si no hi ha dues diapositives, no es mou res.
  if (diapositives.length < 2) return 
  // Per evitar que ens apretin massa vegades el botó.
  treballant = true;                 

  // Calculem la següent
  var seguent = actual-1;
  if (seguent == -1) seguent=diapositives.length-1;

  // Llegim la posició actual == amplada del layer que es veu
  var posicio = parseInt(obteAmplada(diapositives[actual]));
  posicio = posicio - 10;

  if (posicio >= 730) { // Inicialitzem el layer de la dreta
    estableixLeft(diapositives[seguent],750);
    estableixMida(diapositives[seguent],0,400);
  }
  //Ho movem tot cap a l'esquerra  
  mostraLayer(diapositives[seguent]);
  estableixLeft(diapositives[seguent], posicio+10);
  estableixMida(diapositives[seguent], 740-posicio+10, 400);  

  estableixLeft(diapositives[actual], 0);
  estableixMida(diapositives[actual], posicio, 400);  

  // Si no hem acabat, tornem-hi
  if (posicio>10) setTimeout("mouEsquerra();",20);
  else { // Hem acabat. 
    // amaguem la diapositiva antiga
    amagaLayer(diapositives[actual]);
    // acabem de posicionar la diapositiva nova
    estableixMida(diapositives[seguent],740);  
    estableixLeft(diapositives[seguent],10);
    // actualitzem la diapositiva que s'està mostrant
    actual=seguent;
    escriuLayer('infoDiapositives','Diapositiva '+(actual+1)+' de '+diapositives.length+'.');
    // ja ens poden tornar a apretar el botó
    treballant=false;
  }

}

/**
 * Mostra la diapositiva anterior
 * @return
 */
function anteriorDiapositiva(){
  if (treballant) return;
  mouEsquerra();
}

/**
 * Gestió de les tecles
 * @param e
 * @return
 */
function gestionaTecles(e){
    if (obert) {
      var codiTecla;
      if (!e) var e = window.event;
      if (e.keyCode) codiTecla = e.keyCode;
      else if (e.wich) codiTecla = e.wich;
      if (codiTecla==39) seguentDiapositiva();
      else if (codiTecla==37) anteriorDiapositiva();
    }
}

/**
 * Gestió de l'event de ratolí sobre els botons
 * @param btName
 * @return
 */
function botoOver(btName) {
 if (document.images) {
   if (diapositives.length > 1) eval('document.'+btName+'.src='+btName+'Over.src');
   else eval('document.'+btName+'.src='+btName+'Deshabilitat.src');
 }
}

/**
 * Gestió de l'event de ratolí fora dels botons
 * @param btName
 * @return
 */
function botoOut(btName) {
 if (document.images) {
   if (diapositives.length > 1) eval('document.'+btName+'.src='+btName+'Out.src');
   else eval('document.'+btName+'.src='+btName+'Deshabilitat.src');
 }
}

