package net.nitus.museu;

public class Web {
	/**
	 * Construeix el codi html de la capçalera d'una pàgina.
	 * @return String amb el codi html.
	 */
	public static String getHeader(){
		return "<html>\n"+
			   "<head>\n"+
			   "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">\n"+
			   "<title>Museu Municipal de Molins de Rei - Els Jaciments</title>\n"+
			   "<link href=\"/museu/css/diapositives.css\" rel=\"stylesheet\" type=\"text/css\">"+"\n"+
			   "<link rel=\"stylesheet\" type=\"text/css\" href=\"/museu/css/style3.css\">\n"+
			   "<style>\n"+
			   "<!--"+"\n"+
			   "\n"+
			   "\n"+
			   "div { font-family: inherit; }"+"\n"+
			   ".box { clear: both; margin-top: 6px; padding-top: 6px; border-top: 1px solid #666666; }"+"\n"+
			   "-->"+"\n"+
			   "</style>"+"\n";
	}

	/**
	 * Construeix el marc del menú de navegació.
	 * @return String amb l'html corresponent al marc del menú.
	 */
	public static String getMarc(){
		return "<div align=\"right\">"+"\n"+
		   	   "	<table border=\"1\" width=\"100%\" id=\"table1\" style=\"border-width: 0; \" cellpadding=\"0\" cellspacing=\"0\" height=\"177\">"+"\n"+
		   	   "		<tr>"+"\n"+
			   "\n"+
		   	   "			<td style=\"border-style: none; border-width: medium\" colspan=\"3\" align=\"center\">"+"\n"+
		   	   "&nbsp;</td>"+"\n"+
		   	   "		</tr>"+"\n"+
		   	   "		<tr>"+"\n"+
		   	   "			<td style=\"border-style: none; border-width: medium\" colspan=\"3\" align=\"center\">"+"\n"+
		   	   "<p style=\"text-align: center\">"+"\n"+
		   	   "<a href=\"index.html\">"+"\n"+
		   	   "<img border=\"0\" src=\"/museu/image/header1.jpg\" width=\"760\" height=\"62\"></a></td>"+"\n"+
		   	   "		</tr>"+"\n"+
		   	   "		<tr>"+"\n"+
		   	   "			<td style=\"border-style: none; border-width: medium\" colspan=\"3\" bgcolor=\"#9146CE\" align=\"center\" height=\"34%\">"+"\n"+
			   "\n"+
		   	   "			<img border=\"0\" src=\"/museu/image/transpa1.jpg\" width=\"14\" height=\"60\"></td>"+"\n"+
		   	   "		</tr>"+"\n"+
		   	   "		<tr>"+"\n"+
		   	   "			<td style=\"border-style: none; border-width: medium\" align=\"center\" width=\"18%\" bgcolor=\"#9146CE\">&nbsp;</td>"+"\n"+
		   	   "			<td style=\"border-style: none; border-width: medium\" align=\"center\" width=\"66%\" bgcolor=\"#9146CE\">"+"\n"+
		   	   "			<table border=\"1\" width=\"96%\" id=\"table3\">"+"\n"+
		   	   "				<tr>"+"\n"+
		   	   "					<td align=\"center\">"+"\n"+
		   	   "					<p style=\"margin-top: 2px; margin-bottom: 2px\"><font color=\"#FFFFFF\" size=\"2\">["+ 
		   	   "					<a href=\"index.html\"><font color=\"#FFFFFF\">Inici</font></a> ] ["+ "\n"+
		   	   "					<b> "+"\n"+
		   	   "					<a href=\"elmuseu.html\"><font color=\"#FFFFFF\">El museu </font>"+"\n"+
			   "\n"+
		   	   "					</a></b><font size=\"2\">] [ </font><a href=\"informacio.html\">"+"\n"+
		   	   "					<font color=\"#FFFFFF\">Informació</font></a><font size=\"2\"> "+"\n"+
		   	   "					] [ </font><a href=\"exposicions.html\"><font color=\"#FFFFFF\">Exposicions</font></a><font size=\"2\"> ] [ </font>"+"\n"+
		   	   "					<a href=\"activitats.html\"><font color=\"#FFFFFF\">Activitats</font></a><font size=\"2\"> ] [ </font>"+"\n"+
		   	   "					<a href=\"benvinguda.html\"><font color=\"#FFFFFF\">Benvinguda</font></a><font size=\"2\"> ] [ </font>"+"\n"+
			   "\n"+
		   	   "					<a href=\"actualitat.html\"><font color=\"#FFFFFF\">Actualitat</font></a><font size=\"2\"> ] [ "+"\n"+
		   	   "					</font><a href=\"contactar.html\"><font color=\"#FFFFFF\">Contactar</font></a><font size=\"2\"> ]</font></font></td>"+"\n"+
		   	   "				</tr>"+"\n"+
		   	   "			</table>"+"\n"+
		   	   "			</td>"+"\n"+
		   	   "			<td style=\"border-style: none; border-width: medium\" align=\"center\" width=\"16%\" bgcolor=\"#9146CE\">&nbsp;</td>"+"\n"+
		   	   "		</tr>"+	"\n"+
			   "\n"+
		   	   "	</table>"+"\n"+
		   	   "</div>"+"\n";
	}

	/**
	 * Construeix el peu de la pàgina html
	 * @return String amb el codi html del peu de pàgina.
	 */
	public static String getFooter(){
		return "<div id=\"footer\">"+"\n"+
			   "<p>Copyright &copy; Museu Municipal 2009 | Designed by"+"\n"+
			   "<a href=\"http://www.molinsderei.cat\">Ajuntament de Molins de Rei</a> |&nbsp; Valid <a href=\"http://jigsaw.w3.org/css-validator/\">CSS</a> &amp; <a href=\"http://validator.w3.org/\">XHTML</a>"+"\n"+ 
			   "| <a href=\"avislegal.html\"><font color=\"#7534AA\">Avís Legal</font></a></p>"+"\n"+
			   "</div>"+"\n"+
			   "</body>"+"\n"+
			   "</html>";
	}
	
}
